leetcode hot100 之 最长公共子序列

题目

给定两个字符串 text1 和 text2,返回这两个字符串的最长 公共子序列 的长度。如果不存在 公共子序列 ,返回 0 。

一个字符串的 子序列 是指这样一个新的字符串:它是由原字符串在不改变字符的相对顺序的情况下删除某些字符(也可以不删除任何字符)后组成的新字符串。

示例 1:

输入:text1 = "abcde", text2 = "ace"

输出:3

解释:最长公共子序列是 "ace" ,它的长度为 3 。

原题链接:https://leetcode.cn/problems/longest-common-subsequence/description/

思路

以 dpij 表示,text10:i 和 text20:j 的最长公共子序列长度。

找转移方程:

当 texti == textj 时,即两个子字符串末尾的字符相同时,dpij = dpi-1j-1 + 1。

当 texti != textj 时,dpij = max(dpi-1j, dpij-1)。

找边界条件:

当 i=0 或 j=0 时,显然可得 dpi0、dp0j = 0

代码

cpp 复制代码
class Solution {
public:
    int longestCommonSubsequence(string text1, string text2) {
        int m = text1.size();
        int n = text2.size();
        vector<vector<int>> dp(m+1, vector<int> (n+1, 0));
        // if text1[i-1] == text2[j-1], dp[i][j] = dp[i-1][j-1] + 1
        // else, dp[i][j] = max(dp[i][j-1], dp[i-1][j])
        for (int i = 0; i <= m; i++) {
            dp[i][0] = 0;
        }
        for (int j = 0; j <= n; j++) {
            dp[0][j] = 0;
        }
        for (int i = 1; i <= m; i++) {
            for (int j = 1; j <=n; j++) {
                if (text1[i - 1] == text2[j - 1]) {
                    dp[i][j] = dp[i-1][j-1] + 1;
                } else {
                    dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
                }
            }
        }
        return dp[m][n];
    }
};
相关推荐
zx_741484815 小时前
YOLOv3 核心原理详解:Darknet-53 架构、多尺度预测与 FPN 特征融合
算法·yolo·目标检测·yolov3
MoRanzhi12035 小时前
122.四平方和(暴力枚举)
python·数学·算法·蓝桥杯·完全平方数·暴力枚举·四平方和定理
倒头就睡的小比特5 小时前
贪心算法介绍
算法·贪心算法
万少5 小时前
Qoder sonus模型 20分钟,复刻 马斯克 飞天汽车
前端·后端·算法
七牛云行业应用6 小时前
Muse Spark Open 发布:Meta 称其为美国最强开放权重模型,816B 参数如何落地
算法
esop轻Mes看板亮灯分拣ESD静电安6 小时前
产线“最后一米”的破局密码:ESOP与MES的区别与深度协同
算法
陈天伟教授6 小时前
《数据处理和标注技术》课程能力图谱
人工智能·算法
LMT_Lanmantech6 小时前
HyperWorks许可:almutil显示Unit满了,数据到底准不准?
运维·服务器·算法
禁默6 小时前
论文解读与思考:基于场所地图的标识感知机器人探索方法及工程参考的价值
人工智能·深度学习·算法·机器人
维克兜率天6 小时前
【维克】统计套利建模:从因子到信号的完整流程
android·开发语言·python·算法·kotlin